# Specifying a Grammar
## Terminals
{code:c#}
[Terminal(@"\d+")](Terminal(@__d+_))
public class Number : Terminal
{
}
{code:c#}
A terminal is a class that:
* Inherits directly or indirectly from {{Terminal}}.
* Has a public default constructor.
* Is adorned with a {{TeriminalAttribute}} containing the regular expression that defines the terminal.
## Nonterminals
{code:c#}
public class BooleanOperator : Nonterminal
{
}
{code:c#}
A nonterminal is a class that:
* Inherits directly or indirectly from {{Nonterminal}}.
* Has a public default constructor.
## Rules
{code:c#}
public class BooleanOperator : Nonterminal
{
    public static void Rule(BooleanOperator result, OperatorAddition op)
    {
      // Code
    }
}
{code:c#}
A rule is a static method that:
* Contains at least two parameters.
* Specifies a nonterminal as its first parameter.
* Specifies either terminals or nonterminals for all remaining parameters.
